diff --git a/oflog/libsrc/striconv.cc b/oflog/libsrc/striconv.cc
new file mode 100644
index 0000000..26c295a
--- /dev/null
+++ b/oflog/libsrc/striconv.cc
@@ -0,0 +1,269 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+#include "dcmtk/oflog/helpers/strhelp.h"
+
+#if defined (DCMTK_LOG4CPLUS_WITH_ICONV)
+
+#ifdef DCMTK_LOG4CPLUS_HAVE_ICONV_H
+#include <iconv.h>
+#endif
+
+#include <stdexcept>
+#include <iostream>
+#include <sstream>
+#include <cassert>
+#include <cerrno>
+#include <cstring>
+
+
+// This is here because some compilers (Sun CC) think that there is a
+// difference if the typedefs are not in an extern "C" block.
+extern "C"
+{
+
+    //! SUSv3 iconv() type.
+    typedef size_t (& iconv_func_type_1) (iconv_t cd, char * * inbuf,
+	size_t * inbytesleft, char * * outbuf, size_t * outbytesleft); 
+
+
+    //! GNU iconv() type.
+    typedef size_t (& iconv_func_type_2) (iconv_t cd, const char * * inbuf,
+	size_t * inbytesleft, char * * outbuf, size_t * outbytesleft);
+
+} // extern "C"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+namespace helpers
+{
+
+namespace
+{
+
+
+static iconv_t const iconv_error_handle = OFreinterpret_cast(iconv_t, -1);
+
+
+struct iconv_handle
+{
+    iconv_handle (char const * to, char const * from)
+        : handle (iconv_open (to, from))
+    {
+        if (handle == iconv_error_handle)
+        {
+            STD_NAMESPACE ostringstream oss;
+            oss << "iconv_open failed: " << errno;
+            CERR << oss.str () << OFendl;
+            throw STD_NAMESPACE runtime_error (oss.str ().c_str ());
+        }
+    }
+
+    ~iconv_handle ()
+    {
+        if (handle != iconv_error_handle)
+        {
+            int ret = iconv_close (handle);
+            if (ret == -1)
+            {
+                STD_NAMESPACE ostringstream oss;
+                oss << "iconv_close failed: " << errno;
+                CERR << oss.str () << OFendl;
+                throw STD_NAMESPACE runtime_error (oss.str ().c_str ());
+            }
+        }
+    }
+
+    size_t
+    call_iconv (iconv_func_type_1 iconv_func, char * * inbuf,
+        size_t * inbytesleft, char * * outbuf, size_t * outbytesleft)
+    {
+        return iconv_func (handle, inbuf, inbytesleft, outbuf, outbytesleft);
+    }
+
+    size_t
+    call_iconv (iconv_func_type_2 iconv_func, char * * inbuf,
+        size_t * inbytesleft, char * * outbuf, size_t * outbytesleft)
+    {
+        return iconv_func (handle, OFconst_cast(const char * *, inbuf),
+            inbytesleft, outbuf, outbytesleft);
+    }
+
+    size_t
+    do_iconv (char * * inbuf, size_t * inbytesleft, char * * outbuf,
+        size_t * outbytesleft)
+    {
+        return call_iconv (iconv, inbuf, inbytesleft, outbuf, outbytesleft);
+    }
+
+    iconv_t handle;
+};
+
+
+template <typename T>
+struct question_mark;
+
+
+template <>
+struct question_mark<char>
+{
+    static char const value = '?';
+};
+
+
+template <>
+struct question_mark<wchar_t>
+{
+    static wchar_t const value = L'?';
+};
+
+
+char const question_mark<char>::value;
+
+
+wchar_t const question_mark<wchar_t>::value;
+
+
+template <typename DestType, typename SrcType>
+static
+void
+iconv_conv (STD_NAMESPACE basic_string<DestType> & result, char const * destenc,
+    SrcType const * src, size_t size, char const * srcenc)
+{
+    iconv_handle cvt (destenc, srcenc);
+    if (cvt.handle == iconv_error_handle)
+    {
+        // TODO: Better error handling.
+        result.resize (0);
+        return;
+    }
+
+    typedef DestType outbuf_type;
+    typedef SrcType inbuf_type;
+
+    size_t result_size = size + size / 3 + 1;
+    result.resize (result_size);
+
+    char * inbuf = OFconst_cast(char *, OFreinterpret_cast(char const *, src));
+    size_t inbytesleft = size * sizeof (inbuf_type);
+
+    char * outbuf = OFreinterpret_cast(char *, &result[0]);
+    size_t outbytesleft = result_size * sizeof (outbuf_type);
+
+    size_t res;
+    size_t const error_retval = OFstatic_cast(size_t, -1);
+
+    while (inbytesleft != 0)
+    {
+        res = cvt.do_iconv (&inbuf, &inbytesleft, &outbuf, &outbytesleft);
+        if (res == error_retval)
+        {
+            switch (errno)
+            {
+            case EILSEQ:
+            case EINVAL:
+                if (outbytesleft >= sizeof (outbuf_type))
+                {
+                    if (inbytesleft > 0)
+                    {
+                        ++inbuf;
+                        inbytesleft -= sizeof (inbuf_type);
+                    }
+
+                    *outbuf = question_mark<outbuf_type>::value;
+                    ++outbuf;
+                    outbytesleft -= sizeof (outbuf_type);
+                    
+                    continue;
+                }
+
+                // Fall through.
+                
+            case E2BIG:;
+                // Fall through.
+            }
+
+            size_t const outbuf_index = result_size;
+            result_size *= 2;
+            result.resize (result_size);
+            outbuf = OFreinterpret_cast(char *, &result[0] + outbuf_index);
+            outbytesleft = (result_size - outbuf_index) * sizeof (outbuf_type);
+        }
+        else
+            result.resize (result_size - outbytesleft / sizeof (outbuf_type));
+    }
+}
+
+
+} // namespace
+
+
+STD_NAMESPACE string
+tostring (const STD_NAMESPACE wstring & src)
+{
+    STD_NAMESPACE string ret;
+    iconv_conv (ret, "UTF-8", src.c_str (), src.size (), "WCHAR_T");
+    return ret;
+}
+
+
+STD_NAMESPACE string
+tostring (wchar_t const * src)
+{
+    assert (src);
+    STD_NAMESPACE string ret;
+    iconv_conv (ret, "UTF-8", src, STD_NAMESPACE wcslen (src), "WCHAR_T");
+    return ret;
+}
+
+
+STD_NAMESPACE wstring
+towstring (const STD_NAMESPACE string& src)
+{
+    STD_NAMESPACE wstring ret;
+    iconv_conv (ret, "WCHAR_T", src.c_str (), src.size (), "UTF-8");
+    return ret;
+}
+
+
+STD_NAMESPACE wstring
+towstring (char const * src)
+{
+    assert (src);
+    STD_NAMESPACE wstring ret;
+    iconv_conv (ret, "WCHAR_T", src, STD_NAMESPACE strlen (src), "UTF-8");
+    return ret;
+}
+
+
+} // namespace helpers
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+#endif // DCMTK_LOG4CPLUS_WITH_ICONV
diff --git a/oflog/libsrc/syncprims.cc b/oflog/libsrc/syncprims.cc
index 0c1c53f..053855a 100644
--- a/oflog/libsrc/syncprims.cc
+++ b/oflog/libsrc/syncprims.cc
@@ -1,32 +1,38 @@
-//   Copyright (C) 2009, Vaclav Haisman. All rights reserved.
-//
-//   Redistribution and use in source and binary forms, with or without modifica-
-//   tion, are permitted provided that the following conditions are met:
-//
-//   1. Redistributions of  source code must  retain the above copyright  notice,
-//      this list of conditions and the following disclaimer.
-//
-//   2. Redistributions in binary form must reproduce the above copyright notice,
-//      this list of conditions and the following disclaimer in the documentation
-//      and/or other materials provided with the distribution.
-//
-//   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
-//   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
-//   FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
-//   APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
-//   INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
-//   DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
-//   OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
-//   ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
-//   (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
-//   THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-
-//#include <sstream>
-#include "dcmtk/oflog/helpers/syncprims.h"
-#include "dcmtk/ofstd/ofconsol.h"
-
-
-namespace dcmtk { namespace log4cplus { namespace thread { namespace detail {
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include <sstream>
+#include <stdexcept>
+#define DCMTK_LOG4CPLUS_ENABLE_SYNCPRIMS_PUB_IMPL
+#include "dcmtk/oflog/thread/syncpub.h"
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread {
+
+
+namespace impl
+{
 
 
 DCMTK_LOG4CPLUS_EXPORT
@@ -34,11 +40,14 @@ void
 syncprims_throw_exception (char const * const msg, char const * const file,
     int line)
 {
-    //STD_NAMESPACE ostringstream oss;
-    CERR << file << ":" << line << msg;
-    //throw STD_NAMESPACE runtime_error (oss.str ());
-    abort();
+    STD_NAMESPACE ostringstream oss;
+    oss << file << ":" << line << msg;
+    throw STD_NAMESPACE runtime_error (oss.str ());
+}
+
+
 }
 
 
-} } } } // namespace dcmtk { namespace log4cplus { namespace thread { namespace detail {
+} } // namespace log4cplus { namespace thread namespace impl {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/syslogap.cc b/oflog/libsrc/syslogap.cc
index 89c41db..2dca2c2 100644
--- a/oflog/libsrc/syslogap.cc
+++ b/oflog/libsrc/syslogap.cc
@@ -3,7 +3,7 @@
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,39 +18,287 @@
 // limitations under the License.
 
 #include "dcmtk/oflog/syslogap.h"
-#if defined(DCMTK_LOG4CPLUS_HAVE_SYSLOG_H) && !defined(_WIN32)
-
 #include "dcmtk/oflog/streams.h"
+#include "dcmtk/oflog/logmacro.h"
 #include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/helpers/strhelp.h"
 #include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include "dcmtk/oflog/internal/env.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include <cstring>
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
 #include <syslog.h>
 
-using namespace std;
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
+#else // DCMTK_LOG4CPLUS_HAVE_SYSLOG_H
+
+// The following bits were derived from SUSv4 documentation and
+// RFC5424 document.
+
+// priority codes
+#define LOG_EMERG   0
+#define LOG_ALERT   1
+#define LOG_CRIT    2
+#define LOG_ERR     3
+#define LOG_WARNING 4
+#define LOG_NOTICE  5
+#define LOG_INFO    6
+#define LOG_DEBUG   7
+
+// facility codes
+#define LOG_KERN      (0 << 3)
+#define LOG_USER      (1 << 3)
+#define LOG_MAIL      (2 << 3)
+#define LOG_DAEMON    (3 << 3)
+#define LOG_AUTH      (4 << 3)
+#define LOG_SYSLOG    (5 << 3)
+#define LOG_LPR       (6 << 3)
+#define LOG_NEWS      (7 << 3)
+#define LOG_UUCP      (8 << 3)
+#define LOG_CRON      (9 << 3)
+#define LOG_AUTHPRIV (10 << 3)
+#define LOG_FTP      (11 << 3)
+#define LOG_NTP      (12 << 3)
+#define LOG_SECURITY (13 << 3)
+#define LOG_CONSOLE  (14 << 3)
+// (15 << 3) is missing here
+#define LOG_LOCAL0   (16 << 3)
+#define LOG_LOCAL1   (17 << 3)
+#define LOG_LOCAL2   (18 << 3)
+#define LOG_LOCAL3   (19 << 3)
+#define LOG_LOCAL4   (20 << 3)
+#define LOG_LOCAL5   (21 << 3)
+#define LOG_LOCAL6   (22 << 3)
+#define LOG_LOCAL7   (23 << 3)
+
+#endif // DCMTK_LOG4CPLUS_HAVE_SYSLOG_H
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+namespace
+{
+
+static
+const char*
+useIdent (const tstring& string)
+{
+    if (string.empty ())
+        return 0;
+    else
+        return string.c_str ();
+}
+
+
+#ifdef LOG_USER
+int const fallback_facility = LOG_USER;
+
+#else
+int const fallback_facility = 0;
+
+#endif
+
+
+static
+int
+parseFacility (const tstring& text)
+{
+    if (text.empty ())
+        return fallback_facility;
+#ifdef LOG_AUTH
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("auth"))
+        return LOG_AUTH;
+#endif
+#ifdef LOG_AUTHPRIV
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("authpriv"))
+        return LOG_AUTHPRIV;
+#endif
+#ifdef LOG_CONSOLE
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("console"))
+        return LOG_CONSOLE;
+#endif
+#ifdef LOG_CRON
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("cron"))
+        return LOG_CRON;
+#endif
+#ifdef LOG_DAEMON
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("daemon"))
+        return LOG_DAEMON;
+#endif
+#ifdef LOG_FTP
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("ftp"))
+        return LOG_FTP;
+#endif
+#ifdef LOG_KERN
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("kern"))
+        return LOG_KERN;
+#endif
+#ifdef LOG_LOCAL0
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local0"))
+        return LOG_LOCAL0;
+#endif
+#ifdef LOG_LOCAL1
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local1"))
+        return LOG_LOCAL1;
+#endif
+#ifdef LOG_LOCAL2
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local2"))
+        return LOG_LOCAL2;
+#endif
+#ifdef LOG_LOCAL3
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local3"))
+        return LOG_LOCAL3;
+#endif
+#ifdef LOG_LOCAL4
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local4"))
+        return LOG_LOCAL4;
+#endif
+#ifdef LOG_LOCAL5
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local5"))
+        return LOG_LOCAL5;
+#endif
+#ifdef LOG_LOCAL6
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local6"))
+        return LOG_LOCAL6;
+#endif
+#ifdef LOG_LOCAL7
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("local7"))
+        return LOG_LOCAL7;
+#endif
+#ifdef LOG_LPR
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("lpr"))
+        return LOG_LPR;
+#endif
+#ifdef LOG_MAIL
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("mail"))
+        return LOG_MAIL;
+#endif
+#ifdef LOG_NEWS
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("news"))
+        return LOG_NEWS;
+#endif
+#ifdef LOG_NTP
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("ntp"))
+        return LOG_NTP;
+#endif
+#ifdef LOG_SECURITY
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("security"))
+        return LOG_SECURITY;
+#endif
+#ifdef LOG_SYSLOG
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("syslog"))
+        return LOG_SYSLOG;
+#endif
+#ifdef LOG_USER
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("user"))
+        return LOG_USER;
+#endif
+#ifdef LOG_UUCP
+    else if (text == DCMTK_LOG4CPLUS_TEXT ("uucp"))
+        return LOG_UUCP;
+#endif
+    else
+    {
+        // Unknown facility.
+        tstring msg (DCMTK_LOG4CPLUS_TEXT ("Unknown syslog facility: "));
+        msg += text;
+        helpers::getLogLog ().error (msg);
+
+        return fallback_facility;
+    }
+}
 
 
+} // namespace
+
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::SysLogAppender ctors and dtor
+// SysLogAppender ctors and dtor
 ///////////////////////////////////////////////////////////////////////////////
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
 SysLogAppender::SysLogAppender(const tstring& id)
-: ident(id)
+    : ident(id)
+    , facility (0)
+    , appendFunc (&SysLogAppender::appendLocal)
+    , host ()
+    , port (0)
+    , syslogSocket ()
+    // Store STD_NAMESPACE string form of ident as member of SysLogAppender so
+    // the address of the c_str() result remains stable for openlog &
+    // co to use even if we use wstrings.
+    , identStr(DCMTK_LOG4CPLUS_TSTRING_TO_STRING (id) )
+    , hostname (helpers::getHostname (true))
 {
-    ::openlog(DCMTK_LOG4CPLUS_TSTRING_TO_STRING (ident).c_str(), 0, 0);
+    ::openlog(useIdent(identStr), 0, 0);
 }
 
+#endif
+
 
-SysLogAppender::SysLogAppender(const Properties properties, tstring&)
-: Appender(properties)
+SysLogAppender::SysLogAppender(const helpers::Properties & properties)
+    : Appender(properties)
+    , ident ()
+    , facility (0)
+    , appendFunc (0)
+    , host ()
+    , port (0)
+    , syslogSocket ()
+    , identStr ()
+    , hostname (helpers::getHostname (true))
 {
     ident = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("ident") );
-    ::openlog(DCMTK_LOG4CPLUS_TSTRING_TO_STRING (ident).c_str(), 0, 0);
+    facility = parseFacility (
+        helpers::toLower (
+            properties.getProperty (DCMTK_LOG4CPLUS_TEXT ("facility"))));
+    identStr = DCMTK_LOG4CPLUS_TSTRING_TO_STRING (ident);
+
+    host = properties.getProperty (DCMTK_LOG4CPLUS_TEXT ("host"));
+    if (host.empty ())
+    {
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
+        appendFunc = &SysLogAppender::appendLocal;
+        ::openlog(useIdent(identStr), 0, 0);
+
+#else
+        helpers::getLogLog ().error (
+            DCMTK_LOG4CPLUS_TEXT ("SysLogAppender")
+            DCMTK_LOG4CPLUS_TEXT ("- local syslog not available"), true);
+
+#endif
+    }
+    else
+    {
+        if (! properties.getInt (port, DCMTK_LOG4CPLUS_TEXT ("port")))
+            port = 514;
+
+        appendFunc = &SysLogAppender::appendRemote;
+        syslogSocket = helpers::Socket (host, port, true);
+    }
 }
 
 
+SysLogAppender::SysLogAppender(const tstring& id, const tstring & h,
+    int p, const tstring & f)
+    : ident (id)
+    , facility (parseFacility (helpers::toLower (f)))
+    , appendFunc (&SysLogAppender::appendRemote)
+    , host (h)
+    , port (p)
+    , syslogSocket (host, port, true)
+    // Store STD_NAMESPACE string form of ident as member of SysLogAppender so
+    // the address of the c_str() result remains stable for openlog &
+    // co to use even if we use wstrings.
+    , identStr(DCMTK_LOG4CPLUS_TSTRING_TO_STRING (id) )
+    , hostname (helpers::getHostname (true))
+{ }
+
+
 SysLogAppender::~SysLogAppender()
 {
     destructorImpl();
@@ -59,32 +307,38 @@ SysLogAppender::~SysLogAppender()
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::SysLogAppender public methods
+// SysLogAppender public methods
 ///////////////////////////////////////////////////////////////////////////////
 
 void
 SysLogAppender::close()
 {
-    getLogLog().debug(DCMTK_LOG4CPLUS_TEXT("Entering SysLogAppender::close()..."));
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex )
+    helpers::getLogLog().debug(
+        DCMTK_LOG4CPLUS_TEXT("Entering SysLogAppender::close()..."));
+    thread::MutexGuard guard (access_mutex);
+
+    if (host.empty ())
+    {
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
         ::closelog();
-        closed = true;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+#endif
+    }
+    else
+        syslogSocket.close ();
+
+    closed = true;
 }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::SysLogAppender protected methods
+// SysLogAppender protected methods
 ///////////////////////////////////////////////////////////////////////////////
 
 int
 SysLogAppender::getSysLogLevel(const LogLevel& ll) const
 {
-    if(ll < DEBUG_LOG_LEVEL) {
-        return -1;
-    }
-    else if(ll < INFO_LOG_LEVEL) {
+    if(ll < INFO_LOG_LEVEL /* || ll < DEBUG_LOG_LEVEL*/) {
         return LOG_DEBUG;
     }
     else if(ll < WARN_LOG_LEVEL) {
@@ -109,13 +363,73 @@ SysLogAppender::getSysLogLevel(const LogLevel& ll) const
 void
 SysLogAppender::append(const spi::InternalLoggingEvent& event)
 {
-    int level = getSysLogLevel(event.getLogLevel());
-    if(level != -1) {
-        tostringstream buf;
-        layout->formatAndAppend(buf, event);
-        ::syslog(level, "%s", DCMTK_LOG4CPLUS_TSTRING_TO_STRING(buf.str()).c_str());
+    (this->*appendFunc) (event);
+}
+
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
+void
+SysLogAppender::appendLocal(const spi::InternalLoggingEvent& event)
+{
+    int const level = getSysLogLevel(event.getLogLevel());
+    internal::appender_sratch_pad & appender_sp = internal::get_appender_sp ();
+    detail::clear_tostringstream (appender_sp.oss);
+    layout->formatAndAppend(appender_sp.oss, event);
+    appender_sp.str = OFString(appender_sp.oss.str().c_str(), appender_sp.oss.str().length());
+    ::syslog(facility | level, "%s",
+        DCMTK_LOG4CPLUS_TSTRING_TO_STRING(appender_sp.str).c_str());
+}
+
+#endif
+
+
+tstring const SysLogAppender::remoteTimeFormat (
+    DCMTK_LOG4CPLUS_TEXT ("%Y-%m-%dT%H:%M:%S.%qZ"));
+
+
+void
+SysLogAppender::appendRemote(const spi::InternalLoggingEvent& event)
+{
+    int const level = getSysLogLevel(event.getLogLevel());
+    internal::appender_sratch_pad & appender_sp = internal::get_appender_sp ();
+    detail::clear_tostringstream (appender_sp.oss);
+
+    appender_sp.oss
+        // PRI
+        << DCMTK_LOG4CPLUS_TEXT ('<') << (level | facility) << DCMTK_LOG4CPLUS_TEXT ('>')
+        // VERSION
+        << 1
+        // TIMESTAMP
+        << DCMTK_LOG4CPLUS_TEXT (' ')
+        << event.getTimestamp ().getFormattedTime (remoteTimeFormat, true)
+        // HOSTNAME
+        << DCMTK_LOG4CPLUS_TEXT (' ') << hostname
+        // APP-NAME
+        << DCMTK_LOG4CPLUS_TEXT (' ') << ident
+        // PROCID
+        << DCMTK_LOG4CPLUS_TEXT (' ') << internal::get_process_id ()
+        // MSGID
+        << DCMTK_LOG4CPLUS_TEXT (' ') << event.getLoggerName ()
+        // STRUCTURED-DATA
+        // no structured data, it could be whole MDC
+        << DCMTK_LOG4CPLUS_TEXT (" - ");
+
+    // MSG
+    layout->formatAndAppend (appender_sp.oss, event);
+
+    DCMTK_LOG4CPLUS_TSTRING_TO_STRING (appender_sp.oss.str ())
+        .swap (appender_sp.chstr);
+    
+    bool ret = syslogSocket.write (appender_sp.chstr);
+    if (! ret)
+    {
+        helpers::getLogLog ().warn (
+            DCMTK_LOG4CPLUS_TEXT ("SysLogAppender::appendRemote")
+            DCMTK_LOG4CPLUS_TEXT ("- socket write failed"));
+        syslogSocket = helpers::Socket (host, port, true);
     }
 }
 
-#endif // defined(DCMTK_LOG4CPLUS_HAVE_SYSLOG_H)
 
+} // namespace log4cplus
+} // end namespace dcmtk
